local wave = require('wave')

local waves = {}
for f, func in pairs(wave) do
  table.insert(waves, f)
end
local i = 1
local t = 0
local s = love.audio.newSource("squarewave.wav")
s:setLooping(true)
s:setPitch(1)
love.audio.play(s)
 
function love.update(dt)
  t = t + dt
end

function love.draw()
  local f = waves[i]
  local func = wave[f]
  love.graphics.setColor(255,0,0,255)
  love.graphics.print('FPS:'..love.timer.getFPS(), 0, 0)
  love.graphics.print('Wave:' .. f, 0, 20)
  love.graphics.setColor(255,255,255,128)
  for x = 0, 800 do
    local r = func(x/100)
    love.graphics.line(x,0, x,r*300 + 300)
  end
  local a = func(t)
  
  if a > -1 and a <= 1 then
    s:setPitch((a + 1)/2)
  end

  love.graphics.circle('fill', 400,300, (a + 1)/2*255)
  love.graphics.circle('fill', 700,300 + a*255, 64)
  love.graphics.circle('fill', 100,300, 64)
  local r = a*math.pi
  local x, y = math.cos(r)*64, math.sin(r)*64
  love.graphics.line(100, 300, x + 100, y + 300)
end

function love.mousepressed(x, y, button, istouch)
  i = i + 1
  if i > #waves then
    i = 1
  end
end